## tremotesf 2.7.4

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2015-2024 Alexey Rochev
#
# SPDX-License-Identifier: CC0-1.0

cmake_minimum_required(VERSION 3.25)
cmake_policy(VERSION ${CMAKE_MINIMUM_REQUIRED_VERSION}..3.30)

set(languages CXX)
if (APPLE)
    include(cmake/MacOSInitialSetup.cmake)
    list(APPEND languages OBJCXX)
endif ()

project(tremotesf VERSION 2.7.4 LANGUAGES ${languages})

option(TREMOTESF_QT6 "Build with Qt 6" ON)
option(TREMOTESF_ASAN "Build with AddressSanitizer" OFF)

set(TREMOTESF_WITH_HTTPLIB "auto" CACHE STRING "Where to find cpp-httplib dependency for unit tests. Possible values are: auto, system, bundled, none")
if (NOT TREMOTESF_WITH_HTTPLIB MATCHES "^(auto|system|bundled|none)$")
    message(FATAL_ERROR "Invalid TREMOTESF_WITH_HTTPLIB value ${TREMOTESF_WITH_HTTPLIB}. Possible values are: auto, system, bundled, none")
endif()

include(CTest)
include(GNUInstallDirs)

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

include(cmake/CommonOptions.cmake)

find_package(Qt${TREMOTESF_QT_VERSION_MAJOR} ${TREMOTESF_MINIMUM_QT_VERSION} REQUIRED COMPONENTS Core)

set(QRC_FILES "")
if (APPLE)
    set(TREMOTESF_MACOS_BUNDLE_NAME "Tremotesf")
    set(TREMOTESF_EXTERNAL_RESOURCES_PATH "${TREMOTESF_MACOS_BUNDLE_NAME}.app/Contents/Resources")
elseif (WIN32)
    set(TREMOTESF_EXTERNAL_RESOURCES_PATH ".")
endif ()

add_subdirectory("data")
add_subdirectory("translations")
add_subdirectory("src")
add_subdirectory("packaging")

=== data/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2015-2024 Alexey Rochev
#
# SPDX-License-Identifier: CC0-1.0

list(
    APPEND QRC_FILES
    "${CMAKE_CURRENT_SOURCE_DIR}/icons/status/status.qrc"
)

if (TREMOTESF_UNIX_FREEDESKTOP)
    find_package(Gettext 0.21 REQUIRED)

    install(DIRECTORY "icons/hicolor" DESTINATION "${CMAKE_INSTALL_DATADIR}/icons" PATTERN ".DS_Store" EXCLUDE)

    set(po_dir "${CMAKE_CURRENT_SOURCE_DIR}/po")

    set(desktop_file_template "${CMAKE_CURRENT_SOURCE_DIR}/org.equeim.Tremotesf.desktop.in")
    set(desktop_file_path "${CMAKE_CURRENT_BINARY_DIR}/org.equeim.Tremotesf.desktop")
    add_custom_command(
        OUTPUT "${desktop_file_path}"
        COMMAND "${GETTEXT_MSGFMT_EXECUTABLE}"
        ARGS --desktop -d "${po_dir}" --template "${desktop_file_template}" -o "${desktop_file_path}"
        DEPENDS "${desktop_file_template}"
        VERBATIM
    )
    add_custom_target(desktop_file ALL DEPENDS "${desktop_file_path}")
    install(FILES "${desktop_file_path}" DESTINATION "${CMAKE_INSTALL_DATADIR}/applications")

    set(appdata_template "${CMAKE_CURRENT_SOURCE_DIR}/org.equeim.Tremotesf.appdata.xml.in")
    set(appdata_path "${CMAKE_CURRENT_BINARY_DIR}/org.equeim.Tremotesf.appdata.xml")
    add_custom_command(
        OUTPUT "${appdata_path}"
        COMMAND "${GETTEXT_MSGFMT_EXECUTABLE}"
        ARGS --xml -d "${po_dir}" --template "${appdata_template}" -o "${appdata_path}"
        DEPENDS "${appdata_template}"
        VERBATIM
    )
    add_custom_target(appdata ALL DEPENDS "${appdata_path}")
    install(FILES "${appdata_path}" DESTINATION "${CMAKE_INSTALL_DATADIR}/metainfo")
elseif (WIN32 OR APPLE)
    message(STATUS "Building for Windows or macOS, deploying icon themes")

    set(TREMOTESF_BUNDLED_ICON_THEME "breeze")
    set(TREMOTESF_BUNDLED_ICON_THEME ${TREMOTESF_BUNDLED_ICON_THEME} PARENT_SCOPE)

    install(DIRECTORY "icons/hicolor" DESTINATION "${TREMOTESF_EXTERNAL_RESOURCES_PATH}/icons" PATTERN ".DS_Store" EXCLUDE)

    set(hicolor_download_path "${CMAKE_CURRENT_BINARY_DIR}/hicolor/index.theme")
    if (NOT EXISTS "${hicolor_download_path}")
        set(hicolor_url "https://gitlab.freedesktop.org/xdg/default-icon-theme/-/raw/v0.18/index.theme?ref_type=tags&inline=false")
        message(STATUS "Downloading ${hicolor_url} to ${hicolor_download_path}")
        file(
            DOWNLOAD "${hicolor_url}" "${hicolor_download_path}"
            SHOW_PROGRESS
            TLS_VERIFY ON
            EXPECTED_HASH SHA256=a02db5e1b203d981701481bbef8b6fae1c576baf34927eecbc0feae0d2cb9bc5
            STATUS download_status
        )
        list(GET download_status 0 download_status)
        if (NOT download_status EQUAL 0)
            message(FATAL_ERROR "Download failed")
        endif()
    endif()
    install(FILES "${hicolor_download_path}" DESTINATION "${TREMOTESF_EXTERNAL_RESOURCES_PATH}/icons/hicolor")

    set(breeze_download_path "${CMAKE_CURRENT_BINARY_DIR}/breeze.tar.xz")
    set(breeze_version "6.7.0")
    string(REGEX REPLACE "^(.*)\\..*" "\\1" breeze_version_without_patch "${breeze_version}")
    if (NOT EXISTS "${breeze_download_path}")
        set(breeze_url "https://download.kde.org/stable/frameworks/${breeze_version_without_patch}/breeze-icons-${breeze_version}.tar.xz")
        message(STATUS "Downloading ${breeze_url} to ${breeze_download_path}")
        file(
            DOWNLOAD "${breeze_url}" "${breeze_download_path}"
            SHOW_PROGRESS
            TLS_VERIFY ON
            EXPECTED_HASH SHA256=39037e3fcbbb7a65011685c498cae31ff496a5f2493269c955bb29c94a688b74
            STATUS download_status
        )
        list(GET download_status 0 download_status)
        if (NOT download_status EQUAL 0)
            message(FATAL_ERROR "Download failed")
        endif()
        message(STATUS "Extracting ${breeze_download_path} to ${CMAKE_CURRENT_BINARY_DIR}")
        file(ARCHIVE_EXTRACT INPUT "${breeze_download_path}" DESTINATION "${CMAKE_CURRENT_BINARY_DIR}")
    endif()
    set(breeze_extracted_path "${CMAKE_CURRENT_BINARY_DIR}/breeze-icons-${breeze_version}")
    install(CODE "set(breeze_extracted_path [=[${breeze_extracted_path}]=])")
    install(CODE "set(TREMOTESF_EXTERNAL_RESOURCES_PATH [=[${TREMOTESF_EXTERNAL_RESOURCES_PATH}]=])")
    install(SCRIPT InstallBreezeIcons.cmake)
endif()

if (APPLE)
    install(FILES icons/macos/tremotesf.icns DESTINATION "${TREMOTESF_EXTERNAL_RESOURCES_PATH}")
endif ()

set(QRC_FILES ${QRC_FILES} PARENT_SCOPE)

=== src/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2015-2024 Alexey Rochev
#
# SPDX-License-Identifier: CC0-1.0

include(CTest)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(TREMOTESF_COMMON_TARGET_PROPERTIES AUTOMOC ON AUTORCC ON)

find_package(Threads REQUIRED)
find_package(fmt 9.1 REQUIRED)
find_package(cxxopts 3.1.1 REQUIRED)
find_package(Qt${TREMOTESF_QT_VERSION_MAJOR} ${TREMOTESF_MINIMUM_QT_VERSION} REQUIRED COMPONENTS Core Network Widgets)

if (TREMOTESF_QT6)
    set(minimum_kf_version 5.245)
else()
    set(minimum_kf_version 5.103)
endif()
find_package(KF${TREMOTESF_QT_VERSION_MAJOR}WidgetsAddons ${minimum_kf_version} REQUIRED)

find_package(PkgConfig REQUIRED)

if (WIN32 OR APPLE)
    set(registrable_domain_qt ON)
else ()
    set(registrable_domain_qt OFF)
    pkg_check_modules(libpsl REQUIRED IMPORTED_TARGET "libpsl >= 0.21.2")
endif ()

list(APPEND QRC_FILES resources.qrc)

add_library(tremotesf_objects OBJECT)

target_sources(tremotesf_objects
    PRIVATE
    bencodeparser.cpp
    desktoputils.cpp
    filemanagerlauncher.cpp
    fileutils.cpp
    formatutils.cpp
    magnetlinkparser.cpp

    settings.cpp
    torrentfileparser.cpp

    coroutines/coroutines.cpp
    coroutines/scope.cpp
    coroutines/waitall.cpp

    log/demangle.cpp
    log/formatters.cpp
    log/log.cpp
    rpc/addressutils.cpp
    rpc/mounteddirectoriesutils.cpp
    rpc/pathutils.cpp
    rpc/peer.cpp
    rpc/requestrouter.cpp
    rpc/rpc.cpp
    rpc/servers.cpp
    rpc/serversettings.cpp
    rpc/serverstats.cpp
    rpc/torrent.cpp
    rpc/torrentfile.cpp
    rpc/tracker.cpp

    startup/commandlineparser.cpp

    ui/itemmodels/baseproxymodel.cpp
    ui/itemmodels/basetorrentfilesmodel.cpp
    ui/itemmodels/stringlistmodel.cpp
    ui/itemmodels/torrentfilesmodelentry.cpp
    ui/itemmodels/torrentfilesproxymodel.cpp
    ui/notificationscontroller.cpp
    ui/savewindowstatedispatcher.cpp
    ui/screens/aboutdialog.cpp
    ui/screens/addtorrent/addtorrentdialog.cpp
    ui/screens/addtorrent/addtorrenthelpers.cpp
    ui/screens/addtorrent/droppedtorrents.cpp
    ui/screens/addtorrent/localtorrentfilesmodel.cpp
    ui/screens/connectionsettings/connectionsettingsdialog.cpp
    ui/screens/connectionsettings/servereditdialog.cpp
    ui/screens/connectionsettings/serversmodel.cpp
    ui/screens/mainwindow/alltrackersmodel.cpp
    ui/screens/mainwindow/basetorrentsfilterssettingsmodel.cpp
    ui/screens/mainwindow/downloaddirectoriesmodel.cpp
    ui/screens/mainwindow/mainwindow.cpp
    ui/screens/mainwindow/mainwindowsidebar.cpp
    ui/screens/mainwindow/mainwindowstatusbar.cpp
    ui/screens/mainwindow/mainwindowviewmodel.cpp
    ui/screens/mainwindow/statusfiltersmodel.cpp
    ui/screens/mainwindow/torrentsmodel.cpp
    ui/screens/mainwindow/torrentsproxymodel.cpp
    ui/screens/mainwindow/torrentsview.cpp
    ui/screens/serversettings/serversettingsdialog.cpp
    ui/screens/serverstatsdialog.cpp
    ui/screens/settingsdialog.cpp
    ui/screens/torrentproperties/peersmodel.cpp
    ui/screens/torrentproperties/torrentfilesmodel.cpp
    ui/screens/torrentproperties/torrentpropertiesdialog.cpp
    ui/screens/torrentproperties/trackersmodel.cpp
    ui/screens/torrentproperties/trackersviewwidget.cpp
    ui/stylehelpers.cpp
    ui/widgets/basetreeview.cpp
    ui/widgets/commondelegate.cpp
    ui/widgets/remotedirectoryselectionwidget.cpp
    ui/widgets/textinputdialog.cpp
    ui/widgets/torrentfilesview.cpp
    ui/widgets/torrentremotedirectoryselectionwidget.cpp

    ${QRC_FILES}

    PRIVATE FILE_SET HEADERS
    FILES

    bencodeparser.h
    desktoputils.h
    filemanagerlauncher.h
    fileutils.h
    formatutils.h
    itemlistupdater.h
    literals.h
    magnetlinkparser.h
    pragmamacros.h
    settings.h
    stdutils.h
    target_os.h

    macoshelpers.h
    torrentfileparser.h
    unixhelpers.h
    windowshelpers.h

    coroutines/coroutinefwd.h
    coroutines/coroutines.h
    coroutines/hostinfo.h
    coroutines/network.h
    coroutines/qobjectsignal.h
    coroutines/scope.h
    coroutines/threadpool.h
    coroutines/timer.h
    coroutines/waitall.h

    ipc/ipcclient.h
    ipc/ipcserver.h

    log/demangle.h
    log/formatters.h
    log/log.h

    rpc/addressutils.h
    rpc/jsonutils.h
    rpc/mounteddirectoriesutils.h
    rpc/pathutils.h
    rpc/peer.h
    rpc/requestrouter.h
    rpc/rpc.h
    rpc/servers.h
    rpc/serversettings.h
    rpc/serverstats.h
    rpc/torrent.h
    rpc/torrentfile.h
    rpc/tracker.h

    startup/commandlineparser.h
    startup/signalhandler.h

    ui/iconthemesetup.h
    ui/itemmodels/baseproxymodel.h
    ui/itemmodels/basetorrentfilesmodel.h
    ui/itemmodels/modelutils.h
    ui/itemmodels/stringlistmodel.h
    ui/itemmodels/torrentfilesmodelentry.h
    ui/itemmodels/torrentfilesproxymodel.h
    ui/notificationscontroller.h
    ui/savewindowstatedispatcher.h
    ui/screens/aboutdialog.h
    ui/screens/addtorrent/addtorrentdialog.h
    ui/screens/addtorrent/addtorrenthelpers.h
    ui/screens/addtorrent/droppedtorrents.h
    ui/screens/addtorrent/localtorrentfilesmodel.h
    ui/screens/connectionsettings/connectionsettingsdialog.h
    ui/screens/connectionsettings/servereditdialog.h
    ui/screens/connectionsettings/serversmodel.h
    ui/screens/mainwindow/alltrackersmodel.h
    ui/screens/mainwindow/basetorrentsfilterssettingsmodel.h
    ui/screens/mainwindow/downloaddirectoriesmodel.h
    ui/screens/mainwindow/mainwindow.h
    ui/screens/mainwindow/mainwindowsidebar.h
    ui/screens/mainwindow/mainwindowstatusbar.h
    ui/screens/mainwindow/mainwindowviewmodel.h
    ui/screens/mainwindow/statusfiltersmodel.h
    ui/screens/mainwindow/torrentsmodel.h
    ui/screens/mainwindow/torrentsproxymodel.h
    ui/screens/mainwindow/torrentsview.h
    ui/screens/serversettings/serversettingsdialog.h
    ui/screens/serverstatsdialog.h
    ui/screens/settingsdialog.h
    ui/screens/torrentproperties/peersmodel.h
    ui/screens/torrentproperties/torrentfilesmodel.h
    ui/screens/torrentproperties/torrentpropertiesdialog.h
    ui/screens/torrentproperties/trackersmodel.h
    ui/screens/torrentproperties/trackersviewwidget.h
    ui/stylehelpers.h
    ui/systemcolorsprovider.h
    ui/widgets/basetreeview.h
    ui/widgets/commondelegate.h
    ui/widgets/remotedirectoryselectionwidget.h
    ui/widgets/textinputdialog.h
    ui/widgets/torrentfilesview.h
    ui/widgets/torrentremotedirectoryselectionwidget.h
)

target_link_libraries(tremotesf_objects PUBLIC cxxopts::cxxopts Threads::Threads fmt::fmt Qt::Core Qt::Network Qt::Widgets KF${TREMOTESF_QT_VERSION_MAJOR}::WidgetsAddons)

# We need these as CMake variables for configure_file() call below
set(TREMOTESF_APP_NAME "Tremotesf")
set(TREMOTESF_EXECUTABLE_NAME "tremotesf")

target_compile_definitions(
    tremotesf_objects
    PUBLIC
    TREMOTESF_EXECUTABLE_NAME="${TREMOTESF_EXECUTABLE_NAME}"
    TREMOTESF_APP_ID="org.equeim.Tremotesf"
    TREMOTESF_APP_NAME="${TREMOTESF_APP_NAME}"
    TREMOTESF_VERSION="${PROJECT_VERSION}"
    FMT_VERSION_MAJOR=${fmt_VERSION_MAJOR}
)
if (registrable_domain_qt)
    target_compile_definitions(tremotesf_objects PUBLIC TREMOTESF_REGISTRABLE_DOMAIN_QT)
else ()
    target_link_libraries(tremotesf_objects PUBLIC PkgConfig::libpsl)
endif ()

if (UNIX)
    target_sources(
        tremotesf_objects
        PRIVATE
        unixhelpers.cpp
        startup/signalhandler_unix.cpp
    )
    if (TREMOTESF_UNIX_FREEDESKTOP)
        find_package(Qt${TREMOTESF_QT_VERSION_MAJOR} ${TREMOTESF_MINIMUM_QT_VERSION} REQUIRED COMPONENTS DBus)
        find_package(KF${TREMOTESF_QT_VERSION_MAJOR}WindowSystem ${minimum_kf_version} REQUIRED)
        target_link_libraries(tremotesf_objects PUBLIC Qt::DBus KF${TREMOTESF_QT_VERSION_MAJOR}::WindowSystem)

        qt_add_dbus_adaptor(
            dbus_generated
            ipc/org.freedesktop.Application.xml
            ipc/ipcserver_dbus_service.h
            tremotesf::IpcDbusService
            tremotesf_dbus_generated/ipc/org.freedesktop.Application.adaptor
            OrgFreedesktopApplicationAdaptor
        )
        qt_add_dbus_interface(
            dbus_generated
            ipc/org.freedesktop.Application.xml
            tremotesf_dbus_generated/ipc/org.freedesktop.Application
        )
        qt_add_dbus_interface(
            dbus_generated
            org.freedesktop.portal.Notification.xml
            tremotesf_dbus_generated/org.freedesktop.portal.Notification
        )
        qt_add_dbus_interface(
            dbus_generated
            org.freedesktop.Notifications.xml
            tremotesf_dbus_generated/org.freedesktop.Notifications
        )
        qt_add_dbus_interface(
            dbus_generated
            org.freedesktop.FileManager1.xml
            tremotesf_dbus_generated/org.freedesktop.FileManager1
        )

        target_sources(
            tremotesf_objects
            PRIVATE
            filemanagerlauncher_freedesktop.cpp
            ipc/ipcclient_dbus.cpp
            ipc/ipcserver_dbus.cpp
            ipc/ipcserver_dbus_service.cpp
            ui/iconthemesetup_freedesktop.cpp
            ui/notificationscontroller_freedesktop.cpp
            ${dbus_generated}

            PRIVATE FILE_SET HEADERS
            FILES
            coroutines/dbus.h
            ipc/ipcserver_dbus.h
            ipc/ipcserver_dbus_service.h
        )
    else ()
        target_sources(
            tremotesf_objects
            PRIVATE
            ipc/ipcclient_socket.cpp
            ipc/ipcserver_socket.cpp
            ui/notificationscontroller_fallback.cpp

            PRIVATE FILE_SET HEADERS
            FILES
            ipc/ipcserver_socket.h
        )
        if (APPLE)
            target_sources(
                tremotesf_objects
                PRIVATE
                macoshelpers.mm
                filemanagerlauncher_macos.mm
                ipc/fileopeneventhandler.cpp

                PRIVATE FILE_SET HEADERS
                FILES
                ipc/fileopeneventhandler.h
            )
        else ()
            target_sources(
                tremotesf_objects
                PRIVATE
                filemanagerlauncher_fallback.cpp
            )
        endif ()
    endif ()
elseif (WIN32)
    find_library(Dwmapi Dwmapi REQUIRED)
    find_library(RuntimeObject RuntimeObject REQUIRED)
    target_link_libraries(tremotesf_objects PUBLIC Qt::Svg "${Dwmapi}" "${RuntimeObject}")
    target_sources(
        tremotesf_objects
        PRIVATE
        filemanagerlauncher_windows.cpp
        ipc/ipcclient_socket.cpp
        ipc/ipcserver_socket.cpp
        startup/signalhandler_windows.cpp
        startup/windowsfatalerrorhandlers.cpp
        ui/darkthemeapplier_windows.cpp
        ui/notificationscontroller_fallback.cpp
        ui/systemcolorsprovider_windows.cpp
        windowshelpers.cpp

        PRIVATE FILE_SET HEADERS
        FILES
        ipc/ipcserver_socket.h
        startup/windowsfatalerrorhandlers.h
        ui/darkthemeapplier_windows.h
    )
    set(TREMOTESF_WINDOWS_ICON "${CMAKE_CURRENT_SOURCE_DIR}/tremotesf.ico" PARENT_SCOPE)
else ()
    message(FATAL_ERROR "Unsupported target platform ${CMAKE_SYSTEM_NAME}")
endif ()

add_executable(tremotesf startup/main.cpp)
target_link_libraries(tremotesf PRIVATE tremotesf_objects)

# Executable configuration on Windows
if (WIN32)
    include("${CMAKE_SOURCE_DIR}/cmake/WindowsMinimumVersion.cmake")
    configure_file(tremotesf.rc.in tremotesf.rc @ONLY)
    configure_file(tremotesf.manifest.in tremotesf.manifest @ONLY)
    target_sources(
        tremotesf
        PRIVATE
        startup/main_windows.cpp
        startup/windowsmessagehandler.cpp
        "${CMAKE_CURRENT_BINARY_DIR}/tremotesf.rc"

        PRIVATE FILE_SET HEADERS
        FILES
        startup/main_windows.h
        startup/windowsmessagehandler.h
    )
    if (MSVC)
        target_sources(tremotesf PRIVATE "${CMAKE_CURRENT_BINARY_DIR}/tremotesf.manifest")
    else ()
        target_sources(tremotesf PRIVATE tremotesf.manifest.rc)
    endif ()
    if (MSVC)

=== debian/changelog ===
tremotesf (2.7.4-1) unstable; urgency=medium

  * New upstream  release

 -- Antoine Beaupré <anarcat@debian.org>  Mon, 09 Dec 2024 09:26:18 -0500

## tremotesf 2.7.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 # SPDX-License-Identifier: CC0-1.0
 
 cmake_minimum_required(VERSION 3.25)
-cmake_policy(VERSION ${CMAKE_MINIMUM_REQUIRED_VERSION}..3.30)
+cmake_policy(VERSION ${CMAKE_MINIMUM_REQUIRED_VERSION}...3.31)
 
 set(languages CXX)
 if (APPLE)
@@ -11,7 +11,7 @@
     list(APPEND languages OBJCXX)
 endif ()
 
-project(tremotesf VERSION 2.7.4 LANGUAGES ${languages})
+project(tremotesf VERSION 2.7.5 LANGUAGES ${languages})
 
 option(TREMOTESF_QT6 "Build with Qt 6" ON)
 option(TREMOTESF_ASAN "Build with AddressSanitizer" OFF)

=== data/CMakeLists.txt ===
--- 
+++ 
@@ -64,7 +64,7 @@
     install(FILES "${hicolor_download_path}" DESTINATION "${TREMOTESF_EXTERNAL_RESOURCES_PATH}/icons/hicolor")
 
     set(breeze_download_path "${CMAKE_CURRENT_BINARY_DIR}/breeze.tar.xz")
-    set(breeze_version "6.7.0")
+    set(breeze_version "6.9.0")
     string(REGEX REPLACE "^(.*)\\..*" "\\1" breeze_version_without_patch "${breeze_version}")
     if (NOT EXISTS "${breeze_download_path}")
         set(breeze_url "https://download.kde.org/stable/frameworks/${breeze_version_without_patch}/breeze-icons-${breeze_version}.tar.xz")
@@ -73,7 +73,7 @@
             DOWNLOAD "${breeze_url}" "${breeze_download_path}"
             SHOW_PROGRESS
             TLS_VERIFY ON
-            EXPECTED_HASH SHA256=39037e3fcbbb7a65011685c498cae31ff496a5f2493269c955bb29c94a688b74
+            EXPECTED_HASH SHA256=618f633bafb0a5aabaa93eaa6733dfebd6e79303ef1d0a93dcf249181896bed9
             STATUS download_status
         )
         list(GET download_status 0 download_status)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,8 @@
 include(CTest)
 
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
-set(TREMOTESF_COMMON_TARGET_PROPERTIES AUTOMOC ON AUTORCC ON)
+set(CMAKE_AUTOMOC ON)
+set(CMAKE_AUTORCC ON)
 
 find_package(Threads REQUIRED)
 find_package(fmt 9.1 REQUIRED)
@@ -376,3 +377,4 @@
         target_sources(tremotesf PRIVATE tremotesf.manifest.rc)
     endif ()
     if (MSVC)
+        # For C++23's std::stacktrace

=== translations/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2015-2024 Alexey Rochev
#
# SPDX-License-Identifier: CC0-1.0

find_package(Qt${TREMOTESF_QT_VERSION_MAJOR} ${TREMOTESF_MINIMUM_QT_VERSION} REQUIRED COMPONENTS LinguistTools)

add_custom_target(
    update_source_ts
    COMMAND $<TARGET_FILE:Qt::lupdate> "${CMAKE_SOURCE_DIR}/src" -no-obsolete -ts source.ts
    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
)

set(
    ts_files
    de.ts
    en.ts
    es.ts
    es_ES.ts
    fr.ts
    it_IT.ts
    nl_BE.ts
    nl.ts
    pl.ts
    ru.ts
    tr.ts
    zh_CN.ts
)

qt_add_translation(qm_files ${ts_files})
add_custom_target(translations ALL DEPENDS ${qm_files})

set(translations_qrc_content "<RCC>\n<qresource prefix=\"/translations\">")
foreach(qm_file IN LISTS qm_files)
    string(FIND "${qm_file}" "/" last_separator_index REVERSE)
    if (last_separator_index EQUAL -1)
        message(FATAL_ERROR "Did not find last separator in path ${qm_file}")
    endif()
    string(SUBSTRING "${qm_file}" "${last_separator_index}" -1 qm_file)
    string(SUBSTRING "${qm_file}" 1 -1 qm_file)
    string(APPEND translations_qrc_content "\n<file><![CDATA[${qm_file}]]></file>")
endforeach()
string(APPEND translations_qrc_content "\n</qresource>\n</RCC>")

set(translations_qrc "${CMAKE_CURRENT_BINARY_DIR}/translations.qrc")
file(WRITE "${translations_qrc}" "${translations_qrc_content}")

list(APPEND QRC_FILES "${translations_qrc}")
set(QRC_FILES ${QRC_FILES} PARENT_SCOPE)

if (WIN32 OR APPLE)
    message(STATUS "Building for Windows or macOS, deploying Qt translations")

    if (DEFINED VCPKG_TARGET_TRIPLET)
        # vcpkg
        set(relative_qt_translations_dir "translations/Qt6")
    else ()
        # MSYS2
        set(relative_qt_translations_dir "share/qt6/translations")
    endif ()
    if (DEFINED QT_HOST_PATH)
        find_file(qt_translations_dir "${relative_qt_translations_dir}" PATHS "${QT_HOST_PATH}" REQUIRED)
    else ()
        find_file(qt_translations_dir "${relative_qt_translations_dir}" REQUIRED)
    endif ()
    message(STATUS "Deploying Qt translations from ${qt_translations_dir}")
    install(DIRECTORY "${qt_translations_dir}/" DESTINATION "${TREMOTESF_EXTERNAL_RESOURCES_PATH}/qt-translations"
        FILES_MATCHING PATTERN "qt_*.qm" PATTERN "qtbase_*.qm" PATTERN "qtmultimedia_*.qm"
        PATTERN "qt_help*" EXCLUDE)
endif ()

=== debian/changelog ===
tremotesf (2.7.5-1) unstable; urgency=medium

  * New upstream release (Closes: #1092850)

 -- Antoine Beaupré <anarcat@debian.org>  Tue, 28 Jan 2025 17:20:18 -0500

## tremotesf 2.8.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
     list(APPEND languages OBJCXX)
 endif ()
 
-project(tremotesf VERSION 2.7.5 LANGUAGES ${languages})
+project(tremotesf VERSION 2.8.2 LANGUAGES ${languages})
 
 option(TREMOTESF_QT6 "Build with Qt 6" ON)
 option(TREMOTESF_ASAN "Build with AddressSanitizer" OFF)

=== data/CMakeLists.txt ===
--- 
+++ 
@@ -64,7 +64,7 @@
     install(FILES "${hicolor_download_path}" DESTINATION "${TREMOTESF_EXTERNAL_RESOURCES_PATH}/icons/hicolor")
 
     set(breeze_download_path "${CMAKE_CURRENT_BINARY_DIR}/breeze.tar.xz")
-    set(breeze_version "6.9.0")
+    set(breeze_version "6.12.0")
     string(REGEX REPLACE "^(.*)\\..*" "\\1" breeze_version_without_patch "${breeze_version}")
     if (NOT EXISTS "${breeze_download_path}")
         set(breeze_url "https://download.kde.org/stable/frameworks/${breeze_version_without_patch}/breeze-icons-${breeze_version}.tar.xz")
@@ -73,7 +73,7 @@
             DOWNLOAD "${breeze_url}" "${breeze_download_path}"
             SHOW_PROGRESS
             TLS_VERIFY ON
-            EXPECTED_HASH SHA256=618f633bafb0a5aabaa93eaa6733dfebd6e79303ef1d0a93dcf249181896bed9
+            EXPECTED_HASH SHA256=1af979a67c0539f27a8fcbff973c91245584bfb260dd64c206bc691575cbb668
             STATUS download_status
         )
         list(GET download_status 0 download_status)

=== packaging/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2015-2024 Alexey Rochev
#
# SPDX-License-Identifier: CC0-1.0

if (WIN32)
    add_subdirectory("windows")
elseif (APPLE)
    add_subdirectory("macos")
endif()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -85,6 +85,8 @@
     ui/screens/mainwindow/alltrackersmodel.cpp
     ui/screens/mainwindow/basetorrentsfilterssettingsmodel.cpp
     ui/screens/mainwindow/downloaddirectoriesmodel.cpp
+    ui/screens/mainwindow/editlabelsdialog.cpp
+    ui/screens/mainwindow/labelsmodel.cpp
     ui/screens/mainwindow/mainwindow.cpp
     ui/screens/mainwindow/mainwindowsidebar.cpp
     ui/screens/mainwindow/mainwindowstatusbar.cpp
@@ -99,11 +101,14 @@
     ui/screens/torrentproperties/peersmodel.cpp
     ui/screens/torrentproperties/torrentfilesmodel.cpp
     ui/screens/torrentproperties/torrentpropertiesdialog.cpp
+    ui/screens/torrentproperties/torrentpropertieswidget.cpp
     ui/screens/torrentproperties/trackersmodel.cpp
     ui/screens/torrentproperties/trackersviewwidget.cpp
     ui/stylehelpers.cpp
     ui/widgets/basetreeview.cpp
     ui/widgets/commondelegate.cpp
+    ui/widgets/editlabelswidget.cpp
+    ui/widgets/listplaceholder.cpp
     ui/widgets/remotedirectoryselectionwidget.cpp
     ui/widgets/textinputdialog.cpp
     ui/widgets/torrentfilesview.cpp
@@ -186,6 +191,8 @@
     ui/screens/mainwindow/alltrackersmodel.h
     ui/screens/mainwindow/basetorrentsfilterssettingsmodel.h
     ui/screens/mainwindow/downloaddirectoriesmodel.h
+    ui/screens/mainwindow/editlabelsdialog.h
+    ui/screens/mainwindow/labelsmodel.h
     ui/screens/mainwindow/mainwindow.h
     ui/screens/mainwindow/mainwindowsidebar.h
     ui/screens/mainwindow/mainwindowstatusbar.h
@@ -200,12 +207,15 @@
     ui/screens/torrentproperties/peersmodel.h
     ui/screens/torrentproperties/torrentfilesmodel.h
     ui/screens/torrentproperties/torrentpropertiesdialog.h
+    ui/screens/torrentproperties/torrentpropertieswidget.h
     ui/screens/torrentproperties/trackersmodel.h
     ui/screens/torrentproperties/trackersviewwidget.h
     ui/stylehelpers.h
     ui/systemcolorsprovider.h
     ui/widgets/basetreeview.h
     ui/widgets/commondelegate.h
+    ui/widgets/editlabelswidget.h
+    ui/widgets/listplaceholder.h
     ui/widgets/remotedirectoryselectionwidget.h
     ui/widgets/textinputdialog.h
     ui/widgets/torrentfilesview.h
@@ -363,18 +373,3 @@
         tremotesf
         PRIVATE
         startup/main_windows.cpp
-        startup/windowsmessagehandler.cpp
-        "${CMAKE_CURRENT_BINARY_DIR}/tremotesf.rc"
-
-        PRIVATE FILE_SET HEADERS
-        FILES
-        startup/main_windows.h
-        startup/windowsmessagehandler.h
-    )
-    if (MSVC)
-        target_sources(tremotesf PRIVATE "${CMAKE_CURRENT_BINARY_DIR}/tremotesf.manifest")
-    else ()
-        target_sources(tremotesf PRIVATE tremotesf.manifest.rc)
-    endif ()
-    if (MSVC)
-        # For C++23's std::stacktrace

=== packaging/windows/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2015-2024 Alexey Rochev
#
# SPDX-License-Identifier: CC0-1.0

include("../CPackCommon.cmake")

set(CPACK_GENERATOR ZIP WIX)
set(CPACK_PACKAGE_NAME "Tremotesf")
set(CPACK_PACKAGE_VENDOR "Tremotesf")
set(CPACK_PACKAGE_EXECUTABLES "tremotesf;Tremotesf")
set(CPACK_PACKAGE_INSTALL_DIRECTORY "Tremotesf")
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/license.rtf")
set(CPACK_WIX_UPGRADE_GUID "67e0511b-d9de-4b3c-a604-0dd47522d451")
set(CPACK_WIX_PRODUCT_ICON "${TREMOTESF_WINDOWS_ICON}")
set(CPACK_WIX_EXTRA_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/registry.wxs")
set(CPACK_WIX_PATCH_FILE "${CMAKE_CURRENT_SOURCE_DIR}/registry_feature_patch.wxs")

include(CPack)

=== debian/changelog ===
tremotesf (2.8.2-1) unstable; urgency=medium

  * new upstream release: "Crash when failing to parse server response as
    JSON"

 -- Antoine Beaupré <anarcat@debian.org>  Tue, 22 Apr 2025 08:58:54 -0400

tremotesf (2.8.1-1) unstable; urgency=medium

  * New upstream release

 -- Antoine Beaupré <anarcat@debian.org>  Mon, 14 Apr 2025 09:52:56 -0400

=== debian/control ===
Source: tremotesf
Maintainer: Antoine Beaupré <anarcat@debian.org>
Section: net
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               gettext,
               libcpp-httplib-dev,
               libcxxopts-dev,
               libfmt-dev,
               libkf5widgetsaddons-dev,
               libkf5windowsystem-dev,
               libpsl-dev,
               libssl-dev,
               ninja-build,
               pkgconf,
               qtbase5-dev,
               qttools5-dev,
Standards-Version: 4.6.2
Homepage: https://github.com/equeim/tremotesf2
Vcs-Git: https://salsa.debian.org/debian/tremotesf.git
Vcs-Browser: https://salsa.debian.org/debian/tremotesf

Package: tremotesf
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
Recommends: libqt5svg5, kwayland-integration
Suggests: transmission-daemon,
Description: Remote GUI for transmission-daemon
 Tremotesf is yet another, but modern (first-released in 2016)
 cross-platfom GUI for Transmission daemon written in C++ and Qt.
 .
 Features include, but not necessarily limited to:
  * View torrent list
  * Sort torrents
  * Filter torrents by name, status and trackers
  * Start/stop/verify/remove torrents with multi-selection
  * Add torrents from torrent files and magnet links
  * Select which files to download when adding torrent
  * Manage torrent files
  * Add and remove torrent trackers
  * View torrent peers
  * Set torrent limits
  * Change remote server settings
  * View server statistics
  * Multiple servers
  * Supports HTTPS connection
  * Can connect to servers with self-signed certificates (you need to add
    certificate to server settings)
  * Client certificate authentication

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DTREMOTESF_WITH_HTTPLIB=system -DTREMOTESF_QT6=off

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?@ANY_VERSION@(@ARCHIVE_EXT@)%@PACKAGE@-$1$2%" \
      https://github.com/equeim/tremotesf2/tags \
      (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@

## tremotesf 2.9.0

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2015-2025 Alexey Rochev
#
# SPDX-License-Identifier: CC0-1.0

cmake_minimum_required(VERSION 3.25)
cmake_policy(VERSION ${CMAKE_MINIMUM_REQUIRED_VERSION}...4.1)

include(cmake/VcpkgHostTriplet.cmake)

set(languages CXX)
if (APPLE)
    list(APPEND languages OBJCXX)
    include(cmake/MacOSDeploymentTarget.cmake)
    message(STATUS "Setting CMAKE_OSX_DEPLOYMENT_TARGET to ${TREMOTESF_MACOS_DEPLOYMENT_TARGET}")
    set(CMAKE_OSX_DEPLOYMENT_TARGET "${TREMOTESF_MACOS_DEPLOYMENT_TARGET}")
endif ()

project(tremotesf VERSION 2.9.0 LANGUAGES ${languages})

option(TREMOTESF_ASAN "Build with AddressSanitizer" OFF)

set(TREMOTESF_WITH_HTTPLIB "auto" CACHE STRING "Where to find cpp-httplib dependency for unit tests. Possible values are: auto, system, bundled, none")
if (NOT TREMOTESF_WITH_HTTPLIB MATCHES "^(auto|system|bundled|none)$")
    message(FATAL_ERROR "Invalid TREMOTESF_WITH_HTTPLIB value ${TREMOTESF_WITH_HTTPLIB}. Possible values are: auto, system, bundled, none")
endif()

include(CTest)
include(GNUInstallDirs)

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

include(cmake/CommonOptions.cmake)

find_package(Qt6 ${TREMOTESF_MINIMUM_QT_VERSION} REQUIRED COMPONENTS Core)

if (APPLE)
    set(TREMOTESF_MACOS_BUNDLE_NAME "Tremotesf")
    set(TREMOTESF_EXTERNAL_RESOURCES_PATH "${TREMOTESF_MACOS_BUNDLE_NAME}.app/Contents/Resources")
elseif (WIN32)
    set(TREMOTESF_EXTERNAL_RESOURCES_PATH ".")
endif ()

add_subdirectory("src")
add_subdirectory("data")
add_subdirectory("translations")
add_subdirectory("packaging")

=== data/CMakeLists.txt ===
--- 
+++ 
@@ -1,14 +1,11 @@
-# SPDX-FileCopyrightText: 2015-2024 Alexey Rochev
+# SPDX-FileCopyrightText: 2015-2025 Alexey Rochev
 #
 # SPDX-License-Identifier: CC0-1.0
 
-list(
-    APPEND QRC_FILES
-    "${CMAKE_CURRENT_SOURCE_DIR}/icons/status/status.qrc"
-)
+target_sources(tremotesf_objects PRIVATE icons/status/status.qrc)
 
 if (TREMOTESF_UNIX_FREEDESKTOP)
-    find_package(Gettext 0.21 REQUIRED)
+    find_package(Gettext 0.22.5 REQUIRED)
 
     install(DIRECTORY "icons/hicolor" DESTINATION "${CMAKE_INSTALL_DATADIR}/icons" PATTERN ".DS_Store" EXCLUDE)
 
@@ -40,9 +37,6 @@
 elseif (WIN32 OR APPLE)
     message(STATUS "Building for Windows or macOS, deploying icon themes")
 
-    set(TREMOTESF_BUNDLED_ICON_THEME "breeze")
-    set(TREMOTESF_BUNDLED_ICON_THEME ${TREMOTESF_BUNDLED_ICON_THEME} PARENT_SCOPE)
-
     install(DIRECTORY "icons/hicolor" DESTINATION "${TREMOTESF_EXTERNAL_RESOURCES_PATH}/icons" PATTERN ".DS_Store" EXCLUDE)
 
     set(hicolor_download_path "${CMAKE_CURRENT_BINARY_DIR}/hicolor/index.theme")
@@ -64,7 +58,7 @@
     install(FILES "${hicolor_download_path}" DESTINATION "${TREMOTESF_EXTERNAL_RESOURCES_PATH}/icons/hicolor")
 
     set(breeze_download_path "${CMAKE_CURRENT_BINARY_DIR}/breeze.tar.xz")
-    set(breeze_version "6.12.0")
+    set(breeze_version "6.17.0")
     string(REGEX REPLACE "^(.*)\\..*" "\\1" breeze_version_without_patch "${breeze_version}")
     if (NOT EXISTS "${breeze_download_path}")
         set(breeze_url "https://download.kde.org/stable/frameworks/${breeze_version_without_patch}/breeze-icons-${breeze_version}.tar.xz")
@@ -73,7 +67,7 @@
             DOWNLOAD "${breeze_url}" "${breeze_download_path}"
             SHOW_PROGRESS
             TLS_VERIFY ON
-            EXPECTED_HASH SHA256=1af979a67c0539f27a8fcbff973c91245584bfb260dd64c206bc691575cbb668
+            EXPECTED_HASH SHA256=4ffc75886e9a14a2a02da4871600b8c0b5a40756b8e99cbecfb515696d93c3b8
             STATUS download_status
         )
         list(GET download_status 0 download_status)
@@ -87,10 +81,11 @@
     install(CODE "set(breeze_extracted_path [=[${breeze_extracted_path}]=])")
     install(CODE "set(TREMOTESF_EXTERNAL_RESOURCES_PATH [=[${TREMOTESF_EXTERNAL_RESOURCES_PATH}]=])")
     install(SCRIPT InstallBreezeIcons.cmake)
+
+    target_compile_definitions(tremotesf PRIVATE TREMOTESF_BUNDLED_ICON_THEME="breeze")
 endif()
 
 if (APPLE)
     install(FILES icons/macos/tremotesf.icns DESTINATION "${TREMOTESF_EXTERNAL_RESOURCES_PATH}")
 endif ()
 
-set(QRC_FILES ${QRC_FILES} PARENT_SCOPE)

=== packaging/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# SPDX-FileCopyrightText: 2015-2024 Alexey Rochev
+# SPDX-FileCopyrightText: 2015-2025 Alexey Rochev
 #
 # SPDX-License-Identifier: CC0-1.0

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# SPDX-FileCopyrightText: 2015-2024 Alexey Rochev
+# SPDX-FileCopyrightText: 2015-2025 Alexey Rochev
 #
 # SPDX-License-Identifier: CC0-1.0
 
@@ -9,16 +9,12 @@
 set(CMAKE_AUTORCC ON)
 
 find_package(Threads REQUIRED)
-find_package(fmt 9.1 REQUIRED)
-find_package(cxxopts 3.1.1 REQUIRED)
-find_package(Qt${TREMOTESF_QT_VERSION_MAJOR} ${TREMOTESF_MINIMUM_QT_VERSION} REQUIRED COMPONENTS Core Network Widgets)
-
-if (TREMOTESF_QT6)
-    set(minimum_kf_version 5.245)
-else()
-    set(minimum_kf_version 5.103)
-endif()
-find_package(KF${TREMOTESF_QT_VERSION_MAJOR}WidgetsAddons ${minimum_kf_version} REQUIRED)
+find_package(fmt 10.1.0 REQUIRED)
+find_package(cxxopts 3.2.1 REQUIRED)
+find_package(Qt6 ${TREMOTESF_MINIMUM_QT_VERSION} REQUIRED COMPONENTS Core Network Widgets)
+
+set(minimum_kf_version 6.11.0)
+find_package(KF6WidgetsAddons ${minimum_kf_version} REQUIRED)
 
 find_package(PkgConfig REQUIRED)
 
@@ -28,8 +24,6 @@
     set(registrable_domain_qt OFF)
     pkg_check_modules(libpsl REQUIRED IMPORTED_TARGET "libpsl >= 0.21.2")
 endif ()
-
-list(APPEND QRC_FILES resources.qrc)
 
 add_library(tremotesf_objects OBJECT)
 
@@ -56,6 +50,7 @@
     rpc/mounteddirectoriesutils.cpp
     rpc/pathutils.cpp
     rpc/peer.cpp
+    rpc/qsslcertificateformatter.cpp
     rpc/requestrouter.cpp
     rpc/rpc.cpp
     rpc/servers.cpp
@@ -85,6 +80,7 @@
     ui/screens/mainwindow/alltrackersmodel.cpp
     ui/screens/mainwindow/basetorrentsfilterssettingsmodel.cpp
     ui/screens/mainwindow/downloaddirectoriesmodel.cpp
+    ui/screens/mainwindow/downloaddirectorydelegate.cpp
     ui/screens/mainwindow/editlabelsdialog.cpp
     ui/screens/mainwindow/labelsmodel.cpp
     ui/screens/mainwindow/mainwindow.cpp
@@ -106,15 +102,17 @@
     ui/screens/torrentproperties/trackersviewwidget.cpp
     ui/stylehelpers.cpp
     ui/widgets/basetreeview.cpp
-    ui/widgets/commondelegate.cpp
+
     ui/widgets/editlabelswidget.cpp
     ui/widgets/listplaceholder.cpp
+    ui/widgets/progressbardelegate.cpp
     ui/widgets/remotedirectoryselectionwidget.cpp
     ui/widgets/textinputdialog.cpp
+    ui/widgets/tooltipwhenelideddelegate.cpp
     ui/widgets/torrentfilesview.cpp
     ui/widgets/torrentremotedirectoryselectionwidget.cpp
 
-    ${QRC_FILES}
+    resources.qrc
 
     PRIVATE FILE_SET HEADERS
     FILES
@@ -125,7 +123,6 @@
     fileutils.h
     formatutils.h
     itemlistupdater.h
-    literals.h
     magnetlinkparser.h
     pragmamacros.h
     settings.h
@@ -159,6 +156,7 @@
     rpc/mounteddirectoriesutils.h
     rpc/pathutils.h
     rpc/peer.h
+    rpc/qsslcertificateformatter.h
     rpc/requestrouter.h
     rpc/rpc.h
     rpc/servers.h
@@ -191,6 +189,7 @@
     ui/screens/mainwindow/alltrackersmodel.h
     ui/screens/mainwindow/basetorrentsfilterssettingsmodel.h
     ui/screens/mainwindow/downloaddirectoriesmodel.h
+    ui/screens/mainwindow/downloaddirectorydelegate.h
     ui/screens/mainwindow/editlabelsdialog.h
     ui/screens/mainwindow/labelsmodel.h
     ui/screens/mainwindow/mainwindow.h
@@ -213,16 +212,18 @@
     ui/stylehelpers.h
     ui/systemcolorsprovider.h
     ui/widgets/basetreeview.h
-    ui/widgets/commondelegate.h
+
     ui/widgets/editlabelswidget.h
     ui/widgets/listplaceholder.h
+    ui/widgets/progressbardelegate.h
     ui/widgets/remotedirectoryselectionwidget.h
     ui/widgets/textinputdialog.h
+    ui/widgets/tooltipwhenelideddelegate.h
     ui/widgets/torrentfilesview.h
     ui/widgets/torrentremotedirectoryselectionwidget.h
 )
 
-target_link_libraries(tremotesf_objects PUBLIC cxxopts::cxxopts Threads::Threads fmt::fmt Qt::Core Qt::Network Qt::Widgets KF${TREMOTESF_QT_VERSION_MAJOR}::WidgetsAddons)
+target_link_libraries(tremotesf_objects PUBLIC cxxopts::cxxopts Threads::Threads fmt::fmt Qt::Core Qt::Network Qt::Widgets KF6::WidgetsAddons)
 
 # We need these as CMake variables for configure_file() call below
 set(TREMOTESF_APP_NAME "Tremotesf")
@@ -251,9 +252,9 @@
         startup/signalhandler_unix.cpp
     )
     if (TREMOTESF_UNIX_FREEDESKTOP)
-        find_package(Qt${TREMOTESF_QT_VERSION_MAJOR} ${TREMOTESF_MINIMUM_QT_VERSION} REQUIRED COMPONENTS DBus)
-        find_package(KF${TREMOTESF_QT_VERSION_MAJOR}WindowSystem ${minimum_kf_version} REQUIRED)
-        target_link_libraries(tremotesf_objects PUBLIC Qt::DBus KF${TREMOTESF_QT_VERSION_MAJOR}::WindowSystem)
+        find_package(Qt6 ${TREMOTESF_MINIMUM_QT_VERSION} REQUIRED COMPONENTS DBus)
+        find_package(KF6WindowSystem ${minimum_kf_version} REQUIRED)
+        target_link_libraries(tremotesf_objects PUBLIC Qt::DBus KF6::WindowSystem)
 
         qt_add_dbus_adaptor(
             dbus_generated

=== translations/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2015-2025 Alexey Rochev
#
# SPDX-License-Identifier: CC0-1.0

find_package(Qt6 ${TREMOTESF_MINIMUM_QT_VERSION} REQUIRED COMPONENTS LinguistTools)

qt_add_lupdate(
    TS_FILES source.ts
    SOURCE_TARGETS tremotesf_objects tremotesf
)

qt_add_lrelease(
    TS_FILES
        de.ts
        en.ts
        es.ts
        es_ES.ts
        fr.ts
        it_IT.ts
        nl_BE.ts
        nl.ts
        pl.ts
        ru.ts
        tr.ts
        zh_CN.ts
    QM_FILES_OUTPUT_VARIABLE qm_files
)

qt_add_resources(
    tremotesf_objects "translations"
    PREFIX "/translations"
    FILES ${qm_files}
    BASE "${CMAKE_CURRENT_BINARY_DIR}"
)

if (WIN32 OR APPLE)
    message(STATUS "Building for Windows or macOS, deploying Qt translations")

    if (DEFINED VCPKG_TARGET_TRIPLET)
        # vcpkg
        set(relative_qt_translations_dir "translations/Qt6")
    else ()
        # MSYS2
        set(relative_qt_translations_dir "share/qt6/translations")
    endif ()
    if (DEFINED QT_HOST_PATH)
        find_file(qt_translations_dir "${relative_qt_translations_dir}" PATHS "${QT_HOST_PATH}" REQUIRED)
    else ()
        find_file(qt_translations_dir "${relative_qt_translations_dir}" REQUIRED)
    endif ()
    message(STATUS "Deploying Qt translations from ${qt_translations_dir}")
    install(DIRECTORY "${qt_translations_dir}/" DESTINATION "${TREMOTESF_EXTERNAL_RESOURCES_PATH}/qt-translations"
        FILES_MATCHING PATTERN "qt_*.qm" PATTERN "qtbase_*.qm" PATTERN "qtmultimedia_*.qm"
        PATTERN "qt_help*" EXCLUDE)
endif ()

=== packaging/macos/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2015-2025 Alexey Rochev
#
# SPDX-License-Identifier: CC0-1.0

configure_file("Info.plist.in" "${CMAKE_CURRENT_BINARY_DIR}/Info.plist")
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/Info.plist" DESTINATION "${TREMOTESF_MACOS_BUNDLE_NAME}.app/Contents")

install(FILES "!!! ATTENTION !!!.txt" DESTINATION ".")

include("../CPackCommon.cmake")

set(CPACK_GENERATOR DragNDrop)
get_property(is_multi_config GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
if (is_multi_config)
    set(CPACK_PROJECT_CONFIG_FILE "${CMAKE_CURRENT_SOURCE_DIR}/StripExecutable.cmake")
else()
    include(StripExecutable.cmake)
endif()

include(CPack)

=== packaging/windows/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# SPDX-FileCopyrightText: 2015-2024 Alexey Rochev
+# SPDX-FileCopyrightText: 2015-2025 Alexey Rochev
 #
 # SPDX-License-Identifier: CC0-1.0
 
@@ -10,6 +10,8 @@
 set(CPACK_PACKAGE_EXECUTABLES "tremotesf;Tremotesf")
 set(CPACK_PACKAGE_INSTALL_DIRECTORY "Tremotesf")
 set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/license.rtf")
+set(CPACK_WIX_VERSION 4)
+set(CPACK_WIX_INSTALL_SCOPE perMachine)
 set(CPACK_WIX_UPGRADE_GUID "67e0511b-d9de-4b3c-a604-0dd47522d451")
 set(CPACK_WIX_PRODUCT_ICON "${TREMOTESF_WINDOWS_ICON}")
 set(CPACK_WIX_EXTRA_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/registry.wxs")

=== debian/changelog ===
tremotesf (2.9.0-1) unstable; urgency=medium

  * new upstream release
  * could not audit the source change, too large of a diff
  * upgrade to Qt6

 -- Antoine Beaupré <anarcat@debian.org>  Mon, 06 Oct 2025 10:00:40 -0400

=== debian/control ===
--- 
+++ 
@@ -8,14 +8,14 @@
                libcpp-httplib-dev,
                libcxxopts-dev,
                libfmt-dev,
-               libkf5widgetsaddons-dev,
-               libkf5windowsystem-dev,
+               libkf6widgetsaddons-dev,
+               libkf6windowsystem-dev,
                libpsl-dev,
                libssl-dev,
                ninja-build,
                pkgconf,
-               qtbase5-dev,
-               qttools5-dev,
+               qt6-base-dev,
+               qt6-tools-dev,
 Standards-Version: 4.6.2
 Homepage: https://github.com/equeim/tremotesf2
 Vcs-Git: https://salsa.debian.org/debian/tremotesf.git

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DTREMOTESF_WITH_HTTPLIB=system

## tremotesf 2.9.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
     set(CMAKE_OSX_DEPLOYMENT_TARGET "${TREMOTESF_MACOS_DEPLOYMENT_TARGET}")
 endif ()
 
-project(tremotesf VERSION 2.9.0 LANGUAGES ${languages})
+project(tremotesf VERSION 2.9.1 LANGUAGES ${languages})
 
 option(TREMOTESF_ASAN "Build with AddressSanitizer" OFF)

=== data/CMakeLists.txt ===
--- 
+++ 
@@ -58,7 +58,7 @@
     install(FILES "${hicolor_download_path}" DESTINATION "${TREMOTESF_EXTERNAL_RESOURCES_PATH}/icons/hicolor")
 
     set(breeze_download_path "${CMAKE_CURRENT_BINARY_DIR}/breeze.tar.xz")
-    set(breeze_version "6.17.0")
+    set(breeze_version "6.20.0")
     string(REGEX REPLACE "^(.*)\\..*" "\\1" breeze_version_without_patch "${breeze_version}")
     if (NOT EXISTS "${breeze_download_path}")
         set(breeze_url "https://download.kde.org/stable/frameworks/${breeze_version_without_patch}/breeze-icons-${breeze_version}.tar.xz")
@@ -67,7 +67,7 @@
             DOWNLOAD "${breeze_url}" "${breeze_download_path}"
             SHOW_PROGRESS
             TLS_VERIFY ON
-            EXPECTED_HASH SHA256=4ffc75886e9a14a2a02da4871600b8c0b5a40756b8e99cbecfb515696d93c3b8
+            EXPECTED_HASH SHA256=0a47b28a04a086ccb5b4afb51d6677180006819d0d9302524721689bfa4ad13c
             STATUS download_status
         )
         list(GET download_status 0 download_status)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -154,6 +154,7 @@
     rpc/addressutils.h
     rpc/jsonutils.h
     rpc/mounteddirectoriesutils.h
+    rpc/numbervaluerange.h
     rpc/pathutils.h
     rpc/peer.h
     rpc/qsslcertificateformatter.h

=== debian/changelog ===
tremotesf (2.9.1-1) unstable; urgency=medium

  * new upstream release

 -- Antoine Beaupré <anarcat@debian.org>  Mon, 05 Jan 2026 13:38:01 -0500
